unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Menus, ExtCtrls, SaveLVReg, CustSaveIt, Buttons;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    Memo2: TMemo;
    InsertButton: TButton;
    TabSheet4: TTabSheet;
    Memo4: TMemo;
    TabSheet5: TTabSheet;
    Memo5: TMemo;
    SaveListView1: TSaveListView;
    SaveButton: TButton;
    LoadButton: TButton;
    ClearButton: TButton;
    ListView1: TListView;
    procedure InsertButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure SaveListView1AllowSave(Sender: TObject; Allowed: Boolean);
    procedure SaveListView1AllowSaveAs(Sender: TObject; Allowed: Boolean);
    procedure SaveListView1FileSaved(Sender: TObject);
    procedure SaveListView1FileLoaded(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// *** Begin Ignorable Code ***

procedure TForm1.InsertButtonClick(Sender: TObject);
begin
  // TSaveListView: Insert a New Item to the ListView so you can see how
  // the OnAllow Events Work.
  with ListView1.Items.Add do
  begin
    Caption := 'Goodfellow';
    SubItems.Add('John');
    SubItems.Add('34');
    SubItems.Add('435-2456');
    SubItems.Add('Delphi Programmer!');
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.Title := Caption; // Set Application Title to Form's Caption
end;

procedure TForm1.ClearButtonClick(Sender: TObject);
begin
  ListView1.Items.Clear;
end;

// *** End Ignorable Code ***

// *** Begin Important Code ***

procedure TForm1.LoadButtonClick(Sender: TObject);
begin
  SaveListView1.LoadFromFile('c:\test.txt');
end;

procedure TForm1.SaveButtonClick(Sender: TObject);
begin
  SaveListView1.SaveToFile('c:\test.txt');
end;

procedure TForm1.SaveListView1AllowSave(Sender: TObject; Allowed: Boolean);
begin
  // Enable/Disable Save Button
  SaveButton.Enabled := Allowed;
end;

procedure TForm1.SaveListView1AllowSaveAs(Sender: TObject;
  Allowed: Boolean);
begin
  // OnAllowSaveAs is always Allowed when there's items to be saved,
  // so we can also use it to set the Clear Button
  ClearButton.Enabled := Allowed;
end;

procedure TForm1.SaveListView1FileSaved(Sender: TObject);
begin
  // Display Dialog
  ShowMessage('Save to ' + SaveListView1.CurrentFile);
end;

// *** End Important Code ***

procedure TForm1.SaveListView1FileLoaded(Sender: TObject);
begin
  // Display Dialog
  ShowMessage('Loaded from ' + SaveListView1.CurrentFile);
end;

end.
